package de.intevation.flys.client.shared.model;

import java.io.Serializable;
import java.util.HashMap;
import java.util.ArrayList;

import com.smartgwt.client.widgets.form.DynamicForm;

import de.intevation.flys.client.client.ui.PropertyEditor;

/**
 * @author <a href="mailto:raimund.renkert@intevation.de">Raimund Renkert</a>
 */
public class PropertySetting implements Property {

    /**The settings name.*/
    protected String name;

    /** The default value.*/
    protected String value;

    /** Additional attributes.*/
    protected HashMap<String, String> attributes;

    /** The editor dialog. */
    protected PropertyEditor editor;

    /**
     * Create a new StyleSetting for theme attribution.
     */
    public PropertySetting() {
        this.attributes = new HashMap<String, String>();
    }


    /**
     * Create a new PropertySet.
     * @param name The attribute name.
     * @param value The current value.
     */
    public PropertySetting(
        String name,
        String value)
    {
        this.name = name;
        this.value = value;
        this.attributes = new HashMap<String, String>();
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public void setAttribute(String key, String Value) {
        attributes.put(key, value);
    }

    public String getName() {
        return this.name;
    }

    public String getValue() {
        return this.value;
    }

    public String getAttribute(String key) {
        return attributes.get(key);
    }

    public ArrayList<String> getAttributeList() {
        return new ArrayList<String>(attributes.keySet());
    }

    public DynamicForm generateUI() {
        return new DynamicForm();
    }

    public void setEditor(PropertyEditor editor) {
        this.editor = editor;
    }

    public PropertyEditor getEditor() {
        return this.editor;
    }
}

// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
